function Dsp = MIMO_Test_Rx(PARAM,Dsp)
Dsp.RxCutHead = 0; %initialize

%% SNR Estimation
Dsp.RxSnrEstAvg = PARAM.SnrAbs;
  %Warning: Assume perfect SNR estimation.

%% |H| Estimation
Dsp = Rx_HAbs_Estimation(PARAM,Dsp);
% Dsp.RxHAbsEst = abs(Dsp.ChH); %perfect estimation for test purpose

%% phase recovery

Dsp = Rx_Phase_Recovery_WLLS(PARAM,Dsp);
Dsp = Rx_Phase_Recovery_Wiener(PARAM,Dsp);

Dsp = Rx_Phase_Interpolation(PARAM,Dsp); %data truncation included
Dsp = Rx_Symbol_Truncation(PARAM,Dsp); %data truncation included

%% channel estimation
Dsp = Rx_Channel_Estimation(PARAM,Dsp);

%% remove pilot
Dsp = Rx_Remove_Pilot(PARAM,Dsp);

%% Symbol estimation
Dsp = SymbolEstimation(PARAM,Dsp);

%% Symbol Decision
Dsp = SymbolDecision(PARAM,Dsp);

%% Performance Test
Dsp = Rx_Test_BER(PARAM,Dsp);

end %function
