% unwrap every column of the input
function DataOut = Unwrap_Mean(DataIn,AvgNum,CutOff)

%% Supplement incomplete input 
switch nargin
case 1
  AvgNum = 1;
  CutOff = pi;
case 2
  CutOff = pi;
% otherwise    % nargin == 3
end

%% unwrap. avg mode
DataOut = DataIn; %initialize
for i1 = 2 : size(DataIn,1)
  if i1 <= AvgNum
    pAvg = mean(DataOut(1 : i1-1, :), 1);
  else
    pAvg = mean(DataOut(i1 - AvgNum : i1-1, :), 1);
  end
  
  %unwrap
  %[-3pi,-pi]->2pi, [-pi,pi]->0, [pi,3pi]->-2pi, [3pi,5pi]->-4pi
  DataOut(i1,:) = DataIn(i1,:) ...
                - (2 * CutOff) * round((DataIn(i1,:) - pAvg) / (2 * CutOff));
end

%% test plot
% for i1 = 1 : size(DataIn,2)
%   figure;
%   plot(1:size(DataIn,1) , DataIn(:,i1) , 'r.-');hold on;
%   plot(1:size(DataOut,1), DataOut(:,i1), 'b.-');hold on;
% end
end %function
