function Dsp = Rx_Remove_Pilot(PARAM,Dsp)

%% input isolation & coefficients
DataLength = size(Dsp.RxSymbol, 1);

%% clear pilot
PilotIndex = PARAM.PilotIndex;
PilotIndex(PilotIndex > DataLength) = [];

Dsp.RxSymbol(PilotIndex, :) = [];
Dsp.RxThetaRxTx(PilotIndex, :) = [];

%% clear phase NaN

Dsp.RxSymbol(isnan(Dsp.RxThetaRxTx(:,1)), :) = [];
Dsp.RxThetaRxTx(isnan(Dsp.RxThetaRxTx(:,1)), :) = [];

end %function