function Dsp = Rx_Test_BER(PARAM,Dsp)

%% input isolation & coefficients
TxData = Dsp.TxData;
RxData = Dsp.RxData;
[DataLength,~] = size(RxData);

BitPerSymbol = log2(PARAM.SymbolFormat);
CellLength = PARAM.CellLength;

CutHeadTx = Dsp.RxCutHead / CellLength * (CellLength - 1) * BitPerSymbol;
TxData(1 : CutHeadTx, :) = []; %Cut Head %testing
TxData = TxData(1:DataLength, :); %Cut Tail

%% BER test

[~, Dsp.RxBer] = biterr(TxData, RxData);

end %function
